import unit4.collectionsLib.*;
import unit4.utilsLib.*;
import java.util.Scanner;

class quest13_course{
public static Scanner in= new Scanner(System.in);

public static boolean isFlat(BinTreeNode<Integer> t){

  if(t.getLeft()==null &&t.getRight()==null) return true;
  if(t.getLeft()!=null || t.getRight()!=null) return false;
  if( t.getLeft().getInfo()<= t.getInfo() ||  t.getRight().getInfo()<=t.getInfo()) return false;
  return true;
}

private static int numLeaves(BinTreeNode t){
  if(t==null) return 0;
   if(t.getLeft()==null &&t.getRight()==null) return 1;
   return numLeaves(t.getLeft())+numLeaves(t.getRight());
}
private static int numNodes(BinTreeNode t){
  if(t==null)return 0;
  return 1+numNodes(t.getLeft())+numNodes(t.getRight());
}


public static boolean isFlowering(BinTreeNode<Integer> t){
  return 2*numLeaves(t)>numNodes(t);
   }
                  
   public static void main(String [] args){
   BinTreeNode <Integer> t= BinTreeUtils.buildRandomTree(5,1,10);
 
    BinTreeUtils.showTree(t,"RandomTree");
      System.out.println("is flat ="+isFlat(t));
    System.out.println("is flowering ="+isFlowering(t));
  
 
   BinTreeNode<Integer> t21=new  BinTreeNode<Integer>(1);
    BinTreeNode<Integer> t22=new  BinTreeNode<Integer>(1);
    BinTreeNode<Integer> t2=new  BinTreeNode<Integer>(t21,3,t22);
  
    
     
     BinTreeUtils.showTree(t2,"Question tree 2");
    System.out.println("is flat ="+isFlat(t2));
    System.out.println("is flowering ="+isFlowering(t2));
  
  } 
}
      
      
    