import unit4.collectionsLib.*;
import unit4.utilsLib.*;
import java.util.Scanner;

class quest14_course{
public static Scanner in= new Scanner(System.in);

public static boolean areEqualSons(BinTreeNode<Integer> t){

  if(t.getLeft()==null || t.getRight()==null) return false;
  return t.getLeft().getInfo()== t.getRight().getInfo();
}

public static boolean isEqualToFather (BinTreeNode<Integer> t){
   if(t.getLeft()==null && t.getRight()==null) return false;
   if(t.getLeft()!=null && t.getLeft().getInfo()==t.getInfo())return true;
   if(t.getRight()!=null && t.getRight().getInfo()==t.getInfo())return true;
   return false;
}

public static boolean isPlaid(BinTreeNode<Integer> t){
  if(t==null)return true;
   if(t.getLeft()==null && t.getRight()==null) return true;
   if(areEqualSons(t) || isEqualToFather(t)) return false;
   return isPlaid(t.getLeft()) && isPlaid(t.getRight());
   }
                  
   public static void main(String [] args){
   BinTreeNode <Integer> t= BinTreeUtils.buildRandomTree(5,1,10);
 
    BinTreeUtils.showTree(t,"RandomTree");
    System.out.println("is plaid ="+isPlaid(t));

 
   BinTreeNode<Integer> t21=new  BinTreeNode<Integer>(0);
    BinTreeNode<Integer> t22=new  BinTreeNode<Integer>(1);
    BinTreeNode<Integer> t2=new  BinTreeNode<Integer>(t21,2,t22);
  
     BinTreeUtils.showTree(t2,"Question tree 2");
     System.out.println("is plaid ="+isPlaid(t2));
  
    BinTreeNode<Integer> t31=new  BinTreeNode<Integer>(0);
     BinTreeNode<Integer> t32=new  BinTreeNode<Integer>(null,1,t31);
   BinTreeNode<Integer> t33=new  BinTreeNode<Integer>(t32,0,null);
   BinTreeNode<Integer> t34=new  BinTreeNode<Integer>(t33,1,null);
   BinTreeNode<Integer> t3=new  BinTreeNode<Integer>(null,0,t34);
     BinTreeUtils.showTree(t3,"Question tree 2");
     System.out.println("is plaid ="+isPlaid(t3));
     
  } 
}
      
      
    