import unit4.collectionsLib.*;
import unit4.utilsLib.*;
import java.util.Scanner;

class quest15_course{
public static Scanner in= new Scanner(System.in);

private static boolean isExist (BinTreeNode <Integer> t, int x){
  if(t==null)return false;
  if(t.getInfo()==x)return true;
  return isExist(t.getLeft(),x) || isExist(t.getRight(),x);
}

private static boolean isExist(List<Integer> l, int x){
 Node<Integer> p=l.getFirst();
 while(p!=null){
   if(p.getInfo()==x)return true;
   p=p.getNext();
 }
 return false;
}

 
private static void questA(BinTreeNode <Integer> t1, BinTreeNode<Integer> t2, List<Integer> l)
{
  if(t1!=null){
    if(!isExist(t2,t1.getInfo()) && !isExist(l,t1.getInfo()))l.insert(null,t1.getInfo());
    questA(t1.getLeft(),t2,l);
     questA(t1.getRight(),t2,l);
       }
      }

public static List<Integer> quest(BinTreeNode <Integer> t1, BinTreeNode<Integer> t2){
  List<Integer>l=new List<Integer>();
  questA(t1,t2,l);
  return l;
}
 


   public static void main(String [] args){
   BinTreeNode <Integer> t1= BinTreeUtils.buildRandomTree(5,1,10);
     BinTreeUtils.showTree(t1,"RandomTree1");
   
     BinTreeNode <Integer> t2= BinTreeUtils.buildRandomTree(5,1,10);
     BinTreeUtils.showTree(t2,"RandomTree2");
     
     System.out.println(quest(t1,t2));
  } 
}
      
      
    